package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.protocol.TxID;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("SyntheticOrigin")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class SyntheticOrigin implements Marshallable {
	private TxID cause;
	private Url initiator;
	private long feeRefund;

    //
	public TxID getCause() {
	    return cause;
	}
	public void setCause(final TxID value) {
	    this.cause = value;
	}

	public SyntheticOrigin cause(final TxID value) {
	    setCause(value);
	    return this;
	}
	public Url getInitiator() {
	    return initiator;
	}
	public void setInitiator(final Url value) {
	    this.initiator = value;
	}

	public SyntheticOrigin initiator(final Url value) {
	    setInitiator(value);
	    return this;
	}
	public SyntheticOrigin initiator(final String value) {
	    setInitiator(Url.toAccURL(value));
	    return this;
	}
	public long getFeeRefund() {
	    return feeRefund;
	}
	public void setFeeRefund(final long value) {
	    this.feeRefund = value;
	}

	public SyntheticOrigin feeRefund(final long value) {
	    setFeeRefund(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.cause == null)) {
            marshaller.writeTxid(1, this.cause);
        }
        if (!(this.initiator == null)) {
            marshaller.writeUrl(3, this.initiator);
        }
        if (!(this.feeRefund == 0)) {
            marshaller.writeUint(4, this.feeRefund);
        }
        return marshaller.array();
    }
}
